\ Block 8 Fed8A.fth
0 background !
forget Forth_Editor4
variable Forth_Editor4


: addrRange ( addr -- addr ) \ limit to text buffer
   fedBuf$ max
   fedBuf$ maxLines# lWidth# * + 2 - min
;

: findEnd ( -- ) \ actCol# to last char of line
   lWidth# 1 -
   begin
      1- dup
   fedBuf$ actLine# lWidth# * + + c@ 32 <> until
   1+ lWidth# 2 - min
   0 max to actCol#
;

: cur2Add ( -- addr ) \ cursor to addresse
   fedBuf$ actLine# lWidth# * + actCol# + ;

: centerAddr1 ( addr ) \ center line on screen
   addrRange
   fedBuf$ - dup lWidth# / to actLine#
   lWidth# mod to actCol#
      actLine# fedHeight# 2 / - 0 max to startList#
      listFile
;


: jumpHold \ jump to next marker round robin
   holdBuf iHold# cells + @
   iHold# 1+ 3 and to iHold#
   centerAddr1
;

: setHold \ set marker and also blockMarker#
   cur2Add holdBuf setHold# cells + !
   setHold# 1+ 3 and to setHold#
   actLine# to blockMarker#
;

\ fill defs in dict ##########################################################

: fedWords loc \ print words from dict for this file
   cr
   context @ >a
   begin
      a> 4 + @ >b 
   b> 0=   b> 22 >> actFedBlock @ = or while
         b> $FFFF and 100 / 3 .decs space
         a> prtCWord   
         20 a> 9 + length$ - 1 max spaces
         a> @ >a \ crawl link fields
   repeat
endloc ;


: getPosNum { , k# num# -- number } \ get a positive number from keyboard 0 for none
   0 to_num#
   begin
      wkey to_k#
   k# 48 57 within while
      k# emit
      num# 10 *    k# 48 - + to_num#
   repeat
   num#
; forgetLocals

: fedFillDefs \ fill source field in dict from fedBuf$ and show defs
   flush actFedBlock @ actBlock !
   fedBuf$ bBuf maxLines# lWidth# * cmove \ copy to bBuf
   0 bBuf maxLines# lWidth# * + ! \ mark end
   scanDefs
   0 1 at-xy erline
   0 0 at-xy erline fedWords
   cr erline ." Enter Line# " getPosNum
   ?dup if
      to actLine#
      0 to actCol#
      cur2Add
      centerAddr1
   then
;

: prtCurGlos { , addr# } \ print glossary entry of word under cursor
   cur2Add 1+ to_addr#
   begin
      -1 +to_addr#
   addr# 1- c@ 33 <   addr# c@ 32 > and until
   addr# lineBuf$ copyword drop \ get word
   lineBuf$ find$ to_addr# \ gets lfa
      addr# if   
         0 1 at-xy erline
         0 0 at-xy erline
         addr# 32 + prtDefLine \ war 29
      then
; forgetLocals

scanDefs \ update source fields
-->

\ €

