\ ##################################################################
\ Block 10 Prime Benchmark
forget size

8192 constant size ( original: 8190 1024 )
variable flags    size allot


: do-prime \ calculate primes Byte benchmark one iteration
   getus
   flags size 1 fill ( set array )
   0 ( 0 count )
   size 0 do
      flags i + c@ if
         i dup + 3 +
            ( dup . )
         dup i +
         begin dup size <
         while
            0 over flags + c!
            over +
         repeat
         drop drop 1+
      then
   loop
   .
   getus ."  Primes. 1 DL Needs us: " swap - .

;
 ( do-prime )

\ PICO: do-prime  1899 105117us 0.105 f 1 DL
\ do-prime  1899 51165904 255829us 0.26s f. 1 Durchlauf
\ do-prime  1899 56577640 282888 0.28s with trace facility

\ €

\ #################################################################
\ Block 11 Multitasking in Background or in 2nd COG
\ Background Blink via background or in Cog1
0 background !
forget tests
variable tests

57 constant ledPin

: simpleBlink
   getms 9 >> 1 and ledPin pin! ;

\ ' simpleBlink background !

: blinkCog begin simpleBlink again ;

create user1 1000 allot

2 user1 ' blinkCog cogstart \ ( COGnr userArea instruction -- )
\ €